con
_CLKMODE = xtal1 + pll16x
_XINFREQ = 5_000_000 + 0000

SPRX=0
SPRY=1
SPRP=2
SPRC=3

D           = 200 '375            'Distance and Perspective
SD          = 6000 '6000
SZO         = 0
SZS         = 32

MaxPoints   =  256

CX          =  64'128 '64              'Screen Center X 
CY          =  96'192 '96              'Screen Center Y

POLYC  = 0
POLYX1 = 1
POLYY1 = 2
POLYX2 = 3
POLYY2 = 4
POLYX3 = 5
POLYY3 = 6
POLYLN = 7

VAR
  long  txtx,txty
  
  long  cog
  long  frame
  long  T0   
  long  sendsprs

  long  bakbuf


  long  gospin
  long  polypos
  long  sortpos 'keep this before sortlist
  long  sortlist[600]

  long  polyptr
  word  buf[400*7]
  word  buf2[400*7]

  long  done

  long sorttx1
  long sortty1
  long sorttx2
  long sortty2
  long sorttx3
  long sortty3
  long sorttmp

  word  rotverts[MaxPoints*3]

  long mode
  long litepolyptr
  long filledornot

OBJ
  Lite : "GFX_BINARY_Databus"

Pub Start | i,j,k,l,m,dx,dy,ocnt,ss,ocnt2

  waitcnt (clkfreq*2 + cnt)

  Lite.PropGFX_Start

  i:=Lite.PropGFX_TestValid
  if i<>0
    i:=Lite.RequestID

  Lite.SetBasicMode(Lite#PROPGFX_NTSC,Lite#PROPGFX_8BIT_BITMAP_MODE,Lite#PROPGFX_1_3D_COG,Lite#PROPGFX_FILLED_MODE,Lite#PROPGFX_NORMAL_SPRITES)
  Lite.SetBorderColour(7)

  rotatebuf:=@rotverts
  vectors:=@akira000_verts
  polys:=@akira000_faces
  sortlistptr:=@sortlist
  bufptr:=@buf
  backbufptr:=@bakbuf
  polyptrptr:=@polyptr
  cognew(@Do3D,@gospin)

  litepolyptr:=Lite#PROPGFX_PIXEL_BUFF_END6
  Lite.PokeWord(Lite#PROPGFX_3DLISTPTR,litepolyptr)

  Lite.SendPropPal(@akira000_pal,$1600,16 )
  Lite.SendPropPal(@akira000_pal,$160f,16 )

  repeat
    if mode==0
      Lite.SetBasicMode(Lite#PROPGFX_NTSC,Lite#PROPGFX_1BIT_BITMAP_MODE,Lite#PROPGFX_1_3D_COG,filledornot,Lite#PROPGFX_NORMAL_SPRITES)
      mode:=1
    elseif mode==1
      Lite.SetBasicMode(Lite#PROPGFX_NTSC,Lite#PROPGFX_2BIT_BITMAP_MODE,Lite#PROPGFX_1_3D_COG,filledornot,Lite#PROPGFX_NORMAL_SPRITES)
      mode:=2
    elseif mode==2
      Lite.SetBasicMode(Lite#PROPGFX_NTSC,Lite#PROPGFX_8BIT_BITMAP_MODE,Lite#PROPGFX_1_3D_COG,filledornot,Lite#PROPGFX_NORMAL_SPRITES)
      mode:=0
      filledornot:=1-filledornot
    Lite.PokeWord(Lite#PROPGFX_3DLISTPTR,litepolyptr)

    bakbuf:=$2000

    dx:=0
    frame:=0
    repeat while frame<100
      frame++

      gospin:=1
      repeat while gospin==1
      gospin:=2
      repeat while gospin==2
      gospin:=3
      repeat while gospin==3

      bakbuf:=$7000-bakbuf

      gospin:=4
      repeat while gospin==4

      bakbuf:=$7000-bakbuf
      Lite.SendBuf(@bakbuf,$5A,2)
      bakbuf:=$7000-bakbuf
      Lite.WaitVSync        
      Lite.SendBuf(@buf,litepolyptr,polyptr-@buf ) '380,polyptr-@buf )
      Lite.Debug(ss)    
      Lite.DoPolys

      ss++

pub printat(x,y)
  txtx:=x
  txty:=y
  
pub printstring(s)
  repeat while byte[s][0]
    printchar(byte[s][0])
    s++

pub printchar(c)
 T0:=c+32
 Lite.SendBuf(@T0,$1800+((txty<<5+txtx)<<1),2)
 txtx++
 if(txtx>31)
   txtx:=0
   txty++
   if(txty>24)
     txty:=0

pub printhex(v)
  printchar(hextab[(v>>4)&15])
  printchar(hextab[v&15])

DAT

hextab        byte "0123456789ABCDEF"

cos256        byte        127,127,127,127,127,127,126,126,125,124,124,123,122,121,120,119
              byte        118,117,115,114,112,111,109,108,106,104,102,100,98,96,94,92
              byte        90,88,85,83,81,78,76,73,71,68,65,63,60,57,54,51
              byte        48,46,43,40,37,34,31,28,24,21,18,15,12,9,6,3
              byte        0,-3,-6,-9,-12,-15,-18,-21,-24,-28,-31,-34,-37,-40,-43,-46
              byte        -48,-51,-54,-57,-60,-63,-65,-68,-71,-73,-76,-78,-81,-83,-85,-88
              byte        -90,-92,-94,-96,-98,-100,-102,-104,-106,-108,-109,-111,-112,-114,-115,-117
              byte        -118,-119,-120,-121,-122,-123,-124,-124,-125,-126,-126,-127,-127,-127,-127,-127
              byte        -127,-127,-127,-127,-127,-127,-126,-126,-125,-124,-124,-123,-122,-121,-120,-119
              byte        -118,-117,-115,-114,-112,-111,-109,-108,-106,-104,-102,-100,-98,-96,-94,-92
              byte        -90,-88,-85,-83,-81,-78,-76,-73,-71,-68,-65,-63,-60,-57,-54,-51
              byte        -48,-46,-43,-40,-37,-34,-31,-28,-24,-21,-18,-15,-12,-9,-6,-3
              byte        0,3,6,9,12,15,18,21,24,28,31,34,37,40,43,46
              byte        48,51,54,57,60,63,65,68,71,73,76,78,81,83,85,88
              byte        90,92,94,96,98,100,102,104,106,108,109,111,112,114,115,117
              byte        118,119,120,121,122,123,124,124,125,126,126,127,127,127,127,127

'//Converted Object from 'akira000.lwo'
'//Num Verts=209
'//Num Faces=398
'//Num Quads=0
'//Num Tris=398
'//Num Total Tris=398
'//Num Cols=7

'white shirt, red head band, black hair ,grey vest,skin,trousers,wrist band
akira000_pal  byte $1b,$06,$3f,$02,$04,$18,$06,$3f   'word  $6318,$10,$0,$35ad,$429b,$739c,$10

akira000_verts word
 word   -185,   128,    1190
 word   53,     -328,   1311
 word   -169,   32,     1998
 word   117,    -426,   1781
 word   -13,    -210,   1065
 word   -414,   -124,   1295
 word   -307,   4,      1215
 word   -247,   -265,   1380
 word   -308,   -193,   1516
 word   -332,   -33,    1558
 word   -188,   -273,   1485
 word   -8,     -501,   1994
 word   -19,    -362,   2127
 word   -106,   -541,   2006
 word   -178,   -385,   2150
 word   -278,   -270,   2144
 word   -385,   -327,   1695
 word   -137,   -522,   1786
 word   -364,   -157,   1943
 word   -274,   -536,   2057
 word   -378,   -376,   1995
 word   -258,   -456,   1907
 word   -357,   -486,   2081
 word   -281,   -717,   2007
 word   -479,   -638,   1967
 word   -409,   -544,   1739
 word   -190,   -618,   1842
 word   -250,   -881,   1691
 word   -366,   -799,   1773
 word   -498,   -910,   1766
 word   -379,   -1010,  1645
 word   -217,   -944,   1789
 word   -326,   -868,   1874
 word   -459,   -966,   1852
 word   -342,   -1066,  1741
 word   -247,   -1026,  1895
 word   -302,   -960,   1967
 word   -384,   -1048,  1947
 word   -312,   -1121,  1869
 word   -231,   -1080,  1982
 word   -271,   -1025,  2024
 word   -336,   -1083,  2002
 word   -279,   -1166,  1938
 word   -322,   -1049,  2121
 word   -332,   -1213,  2018
 word   -297,   -1073,  2204
 word   -309,   -1276,  2076
 word   -84,    -1057,  2135
 word   -172,   -1110,  2230
 word   -184,   -1304,  2108
 word   -91,    -1249,  2031
 word   -182,   -1204,  1960
 word   -170,   -1016,  2075
 word   -396,   -298,   852
 word   -175,   -483,   1005
 word   -387,   -591,   1279
 word   -543,   -412,   1056
 word   -433,   -547,   893
 word   -268,   -677,   924
 word   -457,   -785,   1026
 word   -562,   -623,   955
 word   -434,   -463,   808
 word   -234,   -688,   867
 word   -485,   -876,   960
 word   -605,   -624,   902
 word   -453,   -451,   455
 word   -313,   -684,   413
 word   -517,   -837,   464
 word   -607,   -630,   439
 word   -439,   -533,   548
 word   -324,   -661,   533
 word   -475,   -740,   551
 word   -547,   -623,   554
 word   -456,   -566,   176
 word   -381,   -672,   7
 word   -477,   -723,   185
 word   -562,   -664,   11
 word   -484,   -494,   20
 word   -614,   -823,   4
 word   -344,   -844,   14
 word   -472,   -843,   129
 word   -558,   -1060,  11
 word   -397,   -1077,  16
 word   -469,   -1011,  92
 word   -25,    -420,   2175
 word   -131,   -268,   2372
 word   -132,   -352,   2350
 word   -45,    -452,   2316
 word   153,    116,    1331
 word   -38,    140,    1270
 word   199,    -113,   1320
 word   151,    70,     1534
 word   9,      164,    1567
 word   153,    -75,    1493
 word   19,     3,      2184
 word   330,    -280,   2032
 word   182,    -170,   2171
 word   161,    -8,     2170
 word   280,    70,     1731
 word   320,    -248,   1813
 word   93,     116,    1970
 word   347,    -178,   2028
 word   314,    37,     2088
 word   245,    -14,    1942
 word   378,    -105,   2107
 word   343,    -163,   1803
 word   491,    -52,    1870
 word   404,    162,    1867
 word   213,    6,      1823
 word   474,    -402,   1545
 word   416,    -365,   1363
 word   476,    -491,   1553
 word   404,    -446,   1328
 word   260,    -484,   1610
 word   365,    -563,   1563
 word   295,    -519,   1347
 word   193,    -457,   1404
 word   259,    -353,   1400
 word   324,    -392,   1607
 word   146,    252,    876
 word   219,    -63,    837
 word   504,    -72,    1061
 word   379,    225,    1022
 word   364,    181,    766
 word   394,    -5,     672
 word   611,    41,     782
 word   513,    217,    833
 word   282,    264,    725
 word   378,    1,      601
 word   693,    66,     702
 word   530,    279,    806
 word   265,    496,    452
 word   383,    331,    265
 word   625,    390,    340
 word   495,    548,    440
 word   337,    400,    489
 word   382,    278,    376
 word   530,    345,    429
 word   469,    440,    508
 word   335,    621,    179
 word   373,    518,    -2
 word   478,    564,    147
 word   470,    674,    7
 word   288,    701,    18
 word   631,    619,    -13
 word   493,    386,    -4
 word   571,    487,    110
 word   792,    437,    -18
 word   714,    295,    -14
 word   705,    390,    64
 word   121,    -289,   2360
 word   106,    -372,   2339
 word   -180,   92,     1586
 word   17,     -237,   1476
 word   -132,   -302,   2640
 word   -71,    -407,   2535
 word   -20,    -472,   2609
 word   87,     -419,   2522
 word   126,    -407,   2614
 word   150,    -279,   2542
 word   86,     -228,   2632
 word   10,     -212,   2560
 word   -51,    -219,   2656
 word   -111,   -258,   2563
 word   0,      -331,   2543
 word   -17,    -455,   2411
 word   -25,    -489,   2309
 word   1,      -456,   2314
 word   244,    -366,   2019
 word   73,     -327,   2129
 word   -249,   -157,   2169
 word   58,     -157,   2216
 word   -117,   -217,   2213
 word   -122,   -270,   2278
 word   103,    -289,   2267
 word   -151,   -295,   2472
 word   -150,   -290,   2430
 word   143,    -318,   2412
 word   155,    -321,   2457
 word   -18,    -476,   2439
 word   -19,    -366,   2206
 word   3,      -199,   2273
 word   1,      -197,   2357
 word   5,      -184,   2422
 word   7,      -180,   2467
 word   -448,   -866,   1661
 word   -417,   -881,   1714
 word   -350,   -908,   1715
 word   -329,   -927,   1643
 word   415,    59,     1402    
 word   352,    77,     1477    
 word   364,    16,     1512    
 word   278,    50,     1506    
 word   431,    52,     1553        
 word   344,    45,     1638
 word   457,    115,    1551    
 word   499,    25,     1574
 word   260,    -77,    1492    
 word   416,    -73,    1398    
 word   345,    -99,    1625   
 word   500,    -106,   1565    
 word   297,    -212,   1483    
 word   406,    -206,   1411    
 word   361,    -219,   1591    
 word   452,    -224,   1524    
 word   305,    -300,   1490    
 word   379,    -299,   1401    
 word   368,    -316,   1558    
 word   433,    -306,   1501

akira000_faces byte
 byte     18, 170,   2,    0
 byte     11,  12, 172,    4
 byte    169, 180,  12,    4
 byte     11,  13,  17,    0
 byte     18,  15, 170,    0
 byte     17,  13,  19,    4
 byte     18,  20,  15,    4
 byte      3, 168,  11,    3
 byte      3,  11,  17,    0
 byte     42,  39,  51,    4
 byte     51,  39,  52,    4
 byte     39,  40,  52,    4
 byte     44,  43,  41,    4
 byte     43,  45,  52,    4
 byte     46,  44,  51,    4
 byte     16,  17,  21,    3
 byte     17,  19,  21,    4
 byte     16,  21,  18,    3
 byte     18,  21,  20,    4
 byte     55,   1,   7,    5
 byte     53,   6,   0,    5
 byte     77,  76,  73,    4
 byte     74,  77,  73,    4
 byte     77,  74,  76,    4
 byte     81,  82,  83,    4
 byte    180,  84, 173,    4
 byte     84,  86, 173,    4
 byte    173,  86,  85,    4
 byte     84,  87,  86,    4
 byte    168, 171, 169,    4
 byte    171, 172, 181,    4
 byte    168,  99,  95,    0
 byte    100,  94,  97,    0
 byte     99, 101,  95,    4
 byte    100,  97, 102,    4
 byte      3,  99, 168,    0
 byte    206, 117, 205,    4
 byte    117, 118, 205,    4
 byte    205, 118, 207,    4
 byte    110, 208, 109,    4
 byte    109, 118, 111,    4
 byte    112, 117, 110,    4
 byte     98, 103,  99,    3
 byte     99, 103, 101,    4
 byte     98, 100, 103,    3
 byte    100, 102, 103,    4
 byte    121,  90,   1,    5
 byte    119,   0,  89,    5
 byte    143, 139, 142,    4
 byte    140, 139, 143,    4
 byte    143, 142, 140,    4
 byte    147, 149, 148,    4
 byte     84, 180, 174,    4
 byte     84, 174, 151,    4
 byte    174, 150, 151,    4
 byte     84, 167,  87,    4
 byte     84, 151, 167,    4
 byte     85,  86, 176,    4
 byte    150, 177, 151,    4
 byte    156, 155, 179,    2
 byte    179, 157, 156,    2
 byte    159, 158, 178,    2
 byte    161, 160, 184,    2
 byte    184, 162, 161,    2
 byte    163, 154, 164,    2
 byte    155, 164, 154,    2
 byte    156, 164, 155,    2
 byte    156, 157, 164,    2
 byte    157, 158, 164,    2
 byte    159, 164, 158,    2
 byte    159, 160, 164,    2
 byte    161, 164, 160,    2
 byte    161, 162, 164,    2
 byte    163, 164, 162,    2
 byte    167, 165, 166,    4
 byte     87, 166, 165,    4
 byte    167, 166,  87,    4
 byte    100,   2,  94,    0
 byte      2, 170,  94,    0
 byte    184, 163, 162,    2
 byte     12, 180, 173,    4
 byte    169, 174, 180,    4
 byte    208, 110, 206,    4
 byte    206, 110, 117,    4
 byte     44,  42,  51,    4
 byte     44,  41,  42,    4
 byte      5,   8,   9,    5
 byte      5,   9,   6,    5
 byte      0,   6,   9,    5
 byte      0,   9, 152,    5
 byte      1,  10,   7,    5
 byte      1, 153,  10,    5
 byte      7,  10,   5,    5
 byte      5,  10,   8,    5
 byte      8,  16,   9,    0
 byte      9,  16,  18,    0
 byte      9,   2, 152,    0
 byte      9,  18,   2,    0
 byte     10, 153,   3,    0
 byte     10,   3,  17,    0
 byte     10,  16,   8,    0
 byte     10,  17,  16,    0
 byte     50,  47,  48,    4
 byte     49,  50,  48,    4
 byte     11, 168, 169,    4
 byte     11, 169,  12,    4
 byte     11,  14,  13,    0
 byte     11, 172,  14,    0
 byte    170,  15, 172,    0
 byte     15,  14, 172,    0
 byte     19,  13,  22,    4
 byte     13,  14,  22,    4
 byte     26,  21,  23,    4
 byte     21,  19,  23,    4
 byte     23,  19,  24,    4
 byte     19,  22,  24,    4
 byte     20,  24,  22,    4
 byte     25,  24,  20,    4
 byte     30, 188,  27,    4
 byte    188, 187,  27,    4
 byte    187, 186,  27,    4
 byte     27, 186,  28,    4
 byte    185,  28, 186,    4
 byte    185,  29,  28,    4
 byte     30,  29, 188,    4
 byte    188,  29, 185,    4
 byte     30,  27,  34,    4
 byte     34,  27,  31,    4
 byte     31,  27,  32,    4
 byte     27,  28,  32,    4
 byte     33,  28,  29,    4
 byte     33,  32,  28,    4
 byte     30,  34,  29,    4
 byte     34,  33,  29,    4
 byte     34,  35,  38,    4
 byte     34,  31,  35,    4
 byte     35,  31,  36,    4
 byte     31,  32,  36,    4
 byte     37,  36,  33,    4
 byte     33,  36,  32,    4
 byte     34,  38,  33,    4
 byte     38,  37,  33,    4
 byte     38,  35,  42,    6
 byte     42,  35,  39,    6
 byte     35,  40,  39,    6
 byte     35,  36,  40,    6
 byte     37,  40,  36,    6
 byte     37,  41,  40,    6
 byte     38,  41,  37,    6
 byte     38,  42,  41,    6
 byte     41,  43,  40,    4
 byte     40,  43,  52,    4
 byte     46,  43,  44,    4
 byte     46,  45,  43,    4
 byte     51,  47,  50,    4
 byte     51,  52,  47,    4
 byte     52,  48,  47,    4
 byte     52,  45,  48,    4
 byte     46,  48,  45,    4
 byte     49,  48,  46,    4
 byte     49,  46,  51,    4
 byte     49,  51,  50,    4
 byte     26,  23, 188,    4
 byte    188,  23, 187,    4
 byte     23, 186, 187,    4
 byte     23,  24, 186,    4
 byte    185, 186,  24,    4
 byte     25, 185,  24,    4
 byte     26, 185,  25,    4
 byte     26, 188, 185,    4
 byte     53,   5,   6,    5
 byte     56,   5,  53,    5
 byte     55,   4,   1,    5
 byte     54,   4,  55,    5
 byte     54,  53,   4,    5
 byte     53,   0,   4,    5
 byte     60,  53,  57,    5
 byte     60,  56,  53,    5
 byte     58,  53,  54,    5
 byte     58,  57,  53,    5
 byte     59,  54,  55,    5
 byte     58,  54,  59,    5
 byte     60,  59,  56,    5
 byte     59,  55,  56,    5
 byte     61,  64,  57,    5
 byte     64,  60,  57,    5
 byte     61,  58,  62,    5
 byte     61,  57,  58,    5
 byte     63,  62,  59,    5
 byte     62,  58,  59,    5
 byte     63,  59,  64,    5
 byte     64,  59,  60,    5
 byte     65,  64,  61,    5
 byte     68,  64,  65,    5
 byte     66,  65,  62,    5
 byte     65,  61,  62,    5
 byte     67,  62,  63,    5
 byte     66,  62,  67,    5
 byte     68,  67,  64,    5
 byte     67,  63,  64,    5
 byte     73,  72,  69,    4
 byte     76,  72,  73,    4
 byte     74,  73,  70,    4
 byte     73,  69,  70,    4
 byte     75,  70,  71,    4
 byte     74,  70,  75,    4
 byte     76,  75,  72,    4
 byte     75,  71,  72,    4
 byte     78,  75,  76,    4
 byte     78,  80,  75,    4
 byte     74,  79,  76,    4
 byte     78,  76,  79,    4
 byte     79,  75,  80,    4
 byte     74,  75,  79,    4
 byte     78,  81,  83,    4
 byte     78,  83,  80,    4
 byte     81,  79,  82,    4
 byte     78,  79,  81,    4
 byte     79,  83,  82,    4
 byte     79,  80,  83,    4
 byte    181, 173, 182,    2
 byte    173,  85, 182,    2
 byte     88,  89,  92,    5
 byte     88,  92,  91,    5
 byte      0,  92,  89,    5
 byte      0, 152,  92,    5
 byte      1,  93, 153,    5
 byte      1,  90,  93,    5
 byte     90,  88,  93,    5
 byte     88,  91,  93,    5
 byte     91,  92,  98,    0
 byte     92, 100,  98,    0
 byte     92,   2, 100,    0
 byte     92, 152,   2,    0
 byte     93,   3, 153,    0
 byte     93,  99,   3,    0
 byte     93,  98,  99,    0
 byte     93,  91,  98,    0
 byte    116, 114, 113,    4
 byte    115, 114, 116,    4
 byte     94, 172, 171,    0
 byte     94, 170, 172,    0
 byte    169, 171, 174,    4
 byte    171, 181, 174,    4
 byte    168,  96, 171,    0
 byte     95,  96, 168,    0
 byte     94, 171,  97,    0
 byte     97, 171,  96,    0
 byte     95, 104,  96,    4
 byte    101, 104,  95,    4
 byte    101, 106, 104,    4
 byte    101, 105, 106,    4
 byte    102, 106, 107,    4
 byte    102, 104, 106,    4
 byte    103, 107, 108,    4
 byte    103, 102, 107,    4
 byte    189, 192, 190,    4
 byte    190, 192, 191,    4
 byte    191, 194, 193,    4
 byte    191, 192, 194,    4
 byte    195, 194, 196,    4
 byte    195, 193, 194,    4
 byte    189, 190, 196,    4
 byte    190, 195, 196,    4
 byte    189, 198, 192,    4
 byte    198, 197, 192,    4
 byte    197, 199, 192,    4
 byte    192, 199, 194,    4
 byte    200, 196, 199,    4
 byte    196, 194, 199,    4
 byte    189, 196, 198,    4
 byte    198, 196, 200,    4
 byte    198, 202, 197,    4
 byte    202, 201, 197,    4
 byte    201, 199, 197,    4
 byte    201, 203, 199,    4
 byte    204, 200, 203,    4
 byte    200, 199, 203,    4
 byte    198, 200, 202,    4
 byte    202, 200, 204,    4
 byte    202, 206, 201,    6
 byte    206, 205, 201,    6
 byte    201, 207, 203,    6
 byte    201, 205, 207,    6
 byte    204, 207, 208,    6
 byte    204, 203, 207,    6
 byte    202, 208, 206,    6
 byte    202, 204, 208,    6
 byte    207, 118, 109,    4
 byte    208, 207, 109,    4
 byte    112, 109, 111,    4
 byte    112, 110, 109,    4
 byte    117, 113, 118,    4
 byte    117, 116, 113,    4
 byte    118, 113, 114,    4
 byte    118, 114, 111,    4
 byte    115, 112, 114,    4
 byte    112, 111, 114,    4
 byte    115, 116, 117,    4
 byte    115, 117, 112,    4
 byte    190, 191, 105,    4
 byte    108, 190, 105,    4
 byte    105, 191, 106,    4
 byte    191, 193, 106,    4
 byte    107, 106, 195,    4
 byte    195, 106, 193,    4
 byte    108, 107, 195,    4
 byte    108, 195, 190,    4
 byte    122, 119,  88,    5
 byte    119,  89,  88,    5
 byte    120, 121,   4,    5
 byte    121,   1,   4,    5
 byte    120,   4, 119,    5
 byte    119,   4,   0,    5
 byte    126, 123, 119,    5
 byte    126, 119, 122,    5
 byte    124, 119, 123,    5
 byte    124, 120, 119,    5
 byte    124, 125, 120,    5
 byte    125, 121, 120,    5
 byte    125, 122, 121,    5
 byte    126, 122, 125,    5
 byte    127, 123, 130,    5
 byte    130, 123, 126,    5
 byte    127, 128, 124,    5
 byte    127, 124, 123,    5
 byte    128, 125, 124,    5
 byte    129, 125, 128,    5
 byte    129, 130, 125,    5
 byte    130, 126, 125,    5
 byte    134, 131, 130,    5
 byte    131, 127, 130,    5
 byte    131, 128, 127,    5
 byte    132, 128, 131,    5
 byte    132, 133, 128,    5
 byte    133, 129, 128,    5
 byte    133, 130, 129,    5
 byte    134, 130, 133,    5
 byte    142, 139, 138,    4
 byte    139, 135, 138,    4
 byte    140, 136, 139,    4
 byte    139, 136, 135,    4
 byte    140, 141, 136,    4
 byte    141, 137, 136,    4
 byte    141, 138, 137,    4
 byte    142, 138, 141,    4
 byte    144, 141, 146,    4
 byte    144, 142, 141,    4
 byte    144, 145, 142,    4
 byte    140, 142, 145,    4
 byte    140, 145, 141,    4
 byte    145, 146, 141,    4
 byte    144, 149, 147,    4
 byte    144, 146, 149,    4
 byte    147, 148, 145,    4
 byte    144, 147, 145,    4
 byte    145, 148, 149,    4
 byte    145, 149, 146,    4
 byte    181, 182, 174,    2
 byte    174, 182, 150,    2
 byte     87, 165,  86,    4
 byte     86, 165, 176,    4
 byte    167, 151, 165,    4
 byte    151, 177, 165,    4
 byte    182, 183, 150,    2
 byte    150, 183, 177,    2
 byte    182,  85, 183,    2
 byte     85, 176, 183,    2
 byte    176, 165, 175,    1
 byte    165, 179, 175,    1
 byte    177, 179, 165,    1
 byte    177, 178, 179,    1
 byte    177, 184, 178,    1
 byte    183, 184, 177,    1
 byte    183, 176, 184,    1
 byte    176, 175, 184,    1
 byte    184, 175, 163,    2
 byte    175, 154, 163,    2
 byte    179, 155, 175,    2
 byte    175, 155, 154,    2
 byte    179, 178, 157,    2
 byte    178, 158, 157,    2
 byte    184, 159, 178,    2
 byte    184, 160, 159,    2
 byte     12, 173, 172,    4
 byte    172, 173, 181,    4
 byte     22,  15,  20,    4
 byte     22,  14,  15,    4
 byte     97,  96, 104,    4
 byte     97, 104, 102,    4
 byte    103, 105, 101,    4
 byte    105, 103, 108,    4
 byte     25,  20,  21,    4
 byte     25,  21,  26,    4
 byte    121,  88,  90,    5
 byte     88, 121, 122,    5
 byte     55,   7,   5,    5
 byte     55,   5,  56,    5

 'white shirt, red head band, black hair ,grey vest,skin,trousers,wrist band
akira000_pal2  byte $1b,$06,$3f,$02,$04,$18,$06,$3f   'word  $6318,$10,$0,$35ad,$429b,$739c,$10

akira000_verts2 word
 word   -185,   128,    1190
 word   53,     -328,   1311
 word   -169,   32,     1998
 word   117,    -426,   1781
 word   -13,    -210,   1065
 word   -414,   -124,   1295
 word   -307,   4,      1215
 word   -247,   -265,   1380
 word   -308,   -193,   1516
 word   -332,   -33,    1558
 word   -188,   -273,   1485
 word   -8,     -501,   1994
 word   -19,    -362,   2127
 word   -106,   -541,   2006
 word   -178,   -385,   2150
 word   -278,   -270,   2144
 word   -385,   -327,   1695
 word   -137,   -522,   1786
 word   -364,   -157,   1943
 word   -274,   -536,   2057
 word   -378,   -376,   1995
 word   -258,   -456,   1907
 word   -357,   -486,   2081
 word   -281,   -717,   2007
 word   -479,   -638,   1967
 word   -409,   -544,   1739
 word   -190,   -618,   1842
 word   -250,   -881,   1691
 word   -366,   -799,   1773
 word   -498,   -910,   1766
 word   -379,   -1010,  1645
 word   -217,   -944,   1789
 word   -326,   -868,   1874
 word   -459,   -966,   1852
 word   -342,   -1066,  1741
 word   -247,   -1026,  1895
 word   -302,   -960,   1967
 word   -384,   -1048,  1947
 word   -312,   -1121,  1869
 word   -231,   -1080,  1982
 word   -271,   -1025,  2024
 word   -336,   -1083,  2002
 word   -279,   -1166,  1938
 word   -322,   -1049,  2121
 word   -332,   -1213,  2018
 word   -297,   -1073,  2204
 word   -309,   -1276,  2076
 word   -84,    -1057,  2135
 word   -172,   -1110,  2230
 word   -184,   -1304,  2108
 word   -91,    -1249,  2031
 word   -182,   -1204,  1960
 word   -170,   -1016,  2075
 word   -396,   -298,   852
 word   -175,   -483,   1005
 word   -387,   -591,   1279
 word   -543,   -412,   1056
 word   -433,   -547,   893
 word   -268,   -677,   924
 word   -457,   -785,   1026
 word   -562,   -623,   955
 word   -434,   -463,   808
 word   -234,   -688,   867
 word   -485,   -876,   960
 word   -605,   -624,   902
 word   -453,   -451,   455
 word   -313,   -684,   413
 word   -517,   -837,   464
 word   -607,   -630,   439
 word   -439,   -533,   548
 word   -324,   -661,   533
 word   -475,   -740,   551
 word   -547,   -623,   554
 word   -456,   -566,   176
 word   -381,   -672,   7
 word   -477,   -723,   185
 word   -562,   -664,   11
 word   -484,   -494,   20
 word   -614,   -823,   4
 word   -344,   -844,   14
 word   -472,   -843,   129
 word   -558,   -1060,  11
 word   -397,   -1077,  16
 word   -469,   -1011,  92
 word   -25,    -420,   2175
 word   -131,   -268,   2372
 word   -132,   -352,   2350
 word   -45,    -452,   2316
 word   153,    116,    1331
 word   -38,    140,    1270
 word   199,    -113,   1320
 word   151,    70,     1534
 word   9,      164,    1567
 word   153,    -75,    1493
 word   19,     3,      2184
 word   330,    -280,   2032
 word   182,    -170,   2171
 word   161,    -8,     2170
 word   280,    70,     1731
 word   320,    -248,   1813
 word   93,     116,    1970
 word   347,    -178,   2028
 word   314,    37,     2088
 word   245,    -14,    1942
 word   378,    -105,   2107
 word   343,    -163,   1803
 word   491,    -52,    1870
 word   404,    162,    1867
 word   213,    6,      1823
 word   474,    -402,   1545
 word   416,    -365,   1363
 word   476,    -491,   1553
 word   404,    -446,   1328
 word   260,    -484,   1610
 word   365,    -563,   1563
 word   295,    -519,   1347
 word   193,    -457,   1404
 word   259,    -353,   1400
 word   324,    -392,   1607
 word   146,    252,    876
 word   219,    -63,    837
 word   504,    -72,    1061
 word   379,    225,    1022
 word   364,    181,    766
 word   394,    -5,     672
 word   611,    41,     782
 word   513,    217,    833
 word   282,    264,    725
 word   378,    1,      601
 word   693,    66,     702
 word   530,    279,    806
 word   265,    496,    452
 word   383,    331,    265
 word   625,    390,    340
 word   495,    548,    440
 word   337,    400,    489
 word   382,    278,    376
 word   530,    345,    429
 word   469,    440,    508
 word   335,    621,    179
 word   373,    518,    -2
 word   478,    564,    147
 word   470,    674,    7
 word   288,    701,    18
 word   631,    619,    -13
 word   493,    386,    -4
 word   571,    487,    110
 word   792,    437,    -18
 word   714,    295,    -14
 word   705,    390,    64
 word   121,    -289,   2360
 word   106,    -372,   2339
 word   -180,   92,     1586
 word   17,     -237,   1476
 word   -132,   -302,   2640
 word   -71,    -407,   2535
 word   -20,    -472,   2609
 word   87,     -419,   2522
 word   126,    -407,   2614
 word   150,    -279,   2542
 word   86,     -228,   2632
 word   10,     -212,   2560
 word   -51,    -219,   2656
 word   -111,   -258,   2563
 word   0,      -331,   2543
 word   -17,    -455,   2411
 word   -25,    -489,   2309
 word   1,      -456,   2314
 word   244,    -366,   2019
 word   73,     -327,   2129
 word   -249,   -157,   2169
 word   58,     -157,   2216
 word   -117,   -217,   2213
 word   -122,   -270,   2278
 word   103,    -289,   2267
 word   -151,   -295,   2472
 word   -150,   -290,   2430
 word   143,    -318,   2412
 word   155,    -321,   2457
 word   -18,    -476,   2439
 word   -19,    -366,   2206
 word   3,      -199,   2273
 word   1,      -197,   2357
 word   5,      -184,   2422
 word   7,      -180,   2467
 word   -448,   -866,   1661
 word   -417,   -881,   1714
 word   -350,   -908,   1715
 word   -329,   -927,   1643
 word   415,    59,     1402    
 word   352,    77,     1477    
 word   364,    16,     1512    
 word   278,    50,     1506    
 word   431,    52,     1553        
 word   344,    45,     1638
 word   457,    115,    1551    
 word   499,    25,     1574
 word   260,    -77,    1492    
 word   416,    -73,    1398    
 word   345,    -99,    1625   
 word   500,    -106,   1565    
 word   297,    -212,   1483    
 word   406,    -206,   1411    
 word   361,    -219,   1591    
 word   452,    -224,   1524    
 word   305,    -300,   1490    
 word   379,    -299,   1401    
 word   368,    -316,   1558    
 word   433,    -306,   1501

akira000_faces2 byte
 byte     18, 170,   2,    0
 byte     11,  12, 172,    4
 byte    169, 180,  12,    4
 byte     11,  13,  17,    0
 byte     18,  15, 170,    0
 byte     17,  13,  19,    4
 byte     18,  20,  15,    4
 byte      3, 168,  11,    3
 byte      3,  11,  17,    0
 byte     42,  39,  51,    4
 byte     51,  39,  52,    4
 byte     39,  40,  52,    4
 byte     44,  43,  41,    4
 byte     43,  45,  52,    4
 byte     46,  44,  51,    4
 byte     16,  17,  21,    3
 byte     17,  19,  21,    4
 byte     16,  21,  18,    3
 byte     18,  21,  20,    4
 byte     55,   1,   7,    5
 byte     53,   6,   0,    5
 byte     77,  76,  73,    4
 byte     74,  77,  73,    4
 byte     77,  74,  76,    4
 byte     81,  82,  83,    4
 byte    180,  84, 173,    4
 byte     84,  86, 173,    4
 byte    173,  86,  85,    4
 byte     84,  87,  86,    4
 byte    168, 171, 169,    4
 byte    171, 172, 181,    4
 byte    168,  99,  95,    0
 byte    100,  94,  97,    0
 byte     99, 101,  95,    4
 byte    100,  97, 102,    4
 byte      3,  99, 168,    0
 byte    206, 117, 205,    4
 byte    117, 118, 205,    4
 byte    205, 118, 207,    4
 byte    110, 208, 109,    4
 byte    109, 118, 111,    4
 byte    112, 117, 110,    4
 byte     98, 103,  99,    3
 byte     99, 103, 101,    4
 byte     98, 100, 103,    3
 byte    100, 102, 103,    4
 byte    121,  90,   1,    5
 byte    119,   0,  89,    5
 byte    143, 139, 142,    4
 byte    140, 139, 143,    4
 byte    143, 142, 140,    4
 byte    147, 149, 148,    4
 byte     84, 180, 174,    4
 byte     84, 174, 151,    4
 byte    174, 150, 151,    4
 byte     84, 167,  87,    4
 byte     84, 151, 167,    4
 byte     85,  86, 176,    4
 byte    150, 177, 151,    4
 byte    156, 155, 179,    2
 byte    179, 157, 156,    2
 byte    159, 158, 178,    2
 byte    161, 160, 184,    2
 byte    184, 162, 161,    2
 byte    163, 154, 164,    2
 byte    155, 164, 154,    2
 byte    156, 164, 155,    2
 byte    156, 157, 164,    2
 byte    157, 158, 164,    2
 byte    159, 164, 158,    2
 byte    159, 160, 164,    2
 byte    161, 164, 160,    2
 byte    161, 162, 164,    2
 byte    163, 164, 162,    2
 byte    167, 165, 166,    4
 byte     87, 166, 165,    4
 byte    167, 166,  87,    4
 byte    100,   2,  94,    0
 byte      2, 170,  94,    0
 byte    184, 163, 162,    2
 byte     12, 180, 173,    4
 byte    169, 174, 180,    4
 byte    208, 110, 206,    4
 byte    206, 110, 117,    4
 byte     44,  42,  51,    4
 byte     44,  41,  42,    4
 byte      5,   8,   9,    5
 byte      5,   9,   6,    5
 byte      0,   6,   9,    5
 byte      0,   9, 152,    5
 byte      1,  10,   7,    5
 byte      1, 153,  10,    5
 byte      7,  10,   5,    5
 byte      5,  10,   8,    5
 byte      8,  16,   9,    0
 byte      9,  16,  18,    0
 byte      9,   2, 152,    0
 byte      9,  18,   2,    0
 byte     10, 153,   3,    0
 byte     10,   3,  17,    0
 byte     10,  16,   8,    0
 byte     10,  17,  16,    0
 byte     50,  47,  48,    4
 byte     49,  50,  48,    4
 byte     11, 168, 169,    4
 byte     11, 169,  12,    4
 byte     11,  14,  13,    0
 byte     11, 172,  14,    0
 byte    170,  15, 172,    0
 byte     15,  14, 172,    0
 byte     19,  13,  22,    4
 byte     13,  14,  22,    4
 byte     26,  21,  23,    4
 byte     21,  19,  23,    4
 byte     23,  19,  24,    4
 byte     19,  22,  24,    4
 byte     20,  24,  22,    4
 byte     25,  24,  20,    4
 byte     30, 188,  27,    4
 byte    188, 187,  27,    4
 byte    187, 186,  27,    4
 byte     27, 186,  28,    4
 byte    185,  28, 186,    4
 byte    185,  29,  28,    4
 byte     30,  29, 188,    4
 byte    188,  29, 185,    4
 byte     30,  27,  34,    4
 byte     34,  27,  31,    4
 byte     31,  27,  32,    4
 byte     27,  28,  32,    4
 byte     33,  28,  29,    4
 byte     33,  32,  28,    4
 byte     30,  34,  29,    4
 byte     34,  33,  29,    4
 byte     34,  35,  38,    4
 byte     34,  31,  35,    4
 byte     35,  31,  36,    4
 byte     31,  32,  36,    4
 byte     37,  36,  33,    4
 byte     33,  36,  32,    4
 byte     34,  38,  33,    4
 byte     38,  37,  33,    4
 byte     38,  35,  42,    6
 byte     42,  35,  39,    6
 byte     35,  40,  39,    6
 byte     35,  36,  40,    6
 byte     37,  40,  36,    6
 byte     37,  41,  40,    6
 byte     38,  41,  37,    6
 byte     38,  42,  41,    6
 byte     41,  43,  40,    4
 byte     40,  43,  52,    4
 byte     46,  43,  44,    4
 byte     46,  45,  43,    4
 byte     51,  47,  50,    4
 byte     51,  52,  47,    4
 byte     52,  48,  47,    4
 byte     52,  45,  48,    4
 byte     46,  48,  45,    4
 byte     49,  48,  46,    4
 byte     49,  46,  51,    4
 byte     49,  51,  50,    4
 byte     26,  23, 188,    4
 byte    188,  23, 187,    4
 byte     23, 186, 187,    4
 byte     23,  24, 186,    4
 byte    185, 186,  24,    4
 byte     25, 185,  24,    4
 byte     26, 185,  25,    4
 byte     26, 188, 185,    4
 byte     53,   5,   6,    5
 byte     56,   5,  53,    5
 byte     55,   4,   1,    5
 byte     54,   4,  55,    5
 byte     54,  53,   4,    5
 byte     53,   0,   4,    5
 byte     60,  53,  57,    5
 byte     60,  56,  53,    5
 byte     58,  53,  54,    5
 byte     58,  57,  53,    5
 byte     59,  54,  55,    5
 byte     58,  54,  59,    5
 byte     60,  59,  56,    5
 byte     59,  55,  56,    5
 byte     61,  64,  57,    5
 byte     64,  60,  57,    5
 byte     61,  58,  62,    5
 byte     61,  57,  58,    5
 byte     63,  62,  59,    5
 byte     62,  58,  59,    5
 byte     63,  59,  64,    5
 byte     64,  59,  60,    5
 byte     65,  64,  61,    5
 byte     68,  64,  65,    5
 byte     66,  65,  62,    5
 byte     65,  61,  62,    5
 byte     67,  62,  63,    5
 byte     66,  62,  67,    5
 byte     68,  67,  64,    5
 byte     67,  63,  64,    5
 byte     73,  72,  69,    4
 byte     76,  72,  73,    4
 byte     74,  73,  70,    4
 byte     73,  69,  70,    4
 byte     75,  70,  71,    4
 byte     74,  70,  75,    4
 byte     76,  75,  72,    4
 byte     75,  71,  72,    4
 byte     78,  75,  76,    4
 byte     78,  80,  75,    4
 byte     74,  79,  76,    4
 byte     78,  76,  79,    4
 byte     79,  75,  80,    4
 byte     74,  75,  79,    4
 byte     78,  81,  83,    4
 byte     78,  83,  80,    4
 byte     81,  79,  82,    4
 byte     78,  79,  81,    4
 byte     79,  83,  82,    4
 byte     79,  80,  83,    4
 byte    181, 173, 182,    2
 byte    173,  85, 182,    2
 byte     88,  89,  92,    5
 byte     88,  92,  91,    5
 byte      0,  92,  89,    5
 byte      0, 152,  92,    5
 byte      1,  93, 153,    5
 byte      1,  90,  93,    5
 byte     90,  88,  93,    5
 byte     88,  91,  93,    5
 byte     91,  92,  98,    0
 byte     92, 100,  98,    0
 byte     92,   2, 100,    0
 byte     92, 152,   2,    0
 byte     93,   3, 153,    0
 byte     93,  99,   3,    0
 byte     93,  98,  99,    0
 byte     93,  91,  98,    0
 byte    116, 114, 113,    4
 byte    115, 114, 116,    4
 byte     94, 172, 171,    0
 byte     94, 170, 172,    0
 byte    169, 171, 174,    4
 byte    171, 181, 174,    4
 byte    168,  96, 171,    0
 byte     95,  96, 168,    0
 byte     94, 171,  97,    0
 byte     97, 171,  96,    0
 byte     95, 104,  96,    4
 byte    101, 104,  95,    4
 byte    101, 106, 104,    4
 byte    101, 105, 106,    4
 byte    102, 106, 107,    4
 byte    102, 104, 106,    4
 byte    103, 107, 108,    4
 byte    103, 102, 107,    4
 byte    189, 192, 190,    4
 byte    190, 192, 191,    4
 byte    191, 194, 193,    4
 byte    191, 192, 194,    4
 byte    195, 194, 196,    4
 byte    195, 193, 194,    4
 byte    189, 190, 196,    4
 byte    190, 195, 196,    4
 byte    189, 198, 192,    4
 byte    198, 197, 192,    4
 byte    197, 199, 192,    4
 byte    192, 199, 194,    4
 byte    200, 196, 199,    4
 byte    196, 194, 199,    4
 byte    189, 196, 198,    4
 byte    198, 196, 200,    4
 byte    198, 202, 197,    4
 byte    202, 201, 197,    4
 byte    201, 199, 197,    4
 byte    201, 203, 199,    4
 byte    204, 200, 203,    4
 byte    200, 199, 203,    4
 byte    198, 200, 202,    4
 byte    202, 200, 204,    4
 byte    202, 206, 201,    6
 byte    206, 205, 201,    6
 byte    201, 207, 203,    6
 byte    201, 205, 207,    6
 byte    204, 207, 208,    6
 byte    204, 203, 207,    6
 byte    202, 208, 206,    6
 byte    202, 204, 208,    6
 byte    207, 118, 109,    4
 byte    208, 207, 109,    4
 byte    112, 109, 111,    4
 byte    112, 110, 109,    4
 byte    117, 113, 118,    4
 byte    117, 116, 113,    4
 byte    118, 113, 114,    4
 byte    118, 114, 111,    4
 byte    115, 112, 114,    4
 byte    112, 111, 114,    4
 byte    115, 116, 117,    4
 byte    115, 117, 112,    4
 byte    190, 191, 105,    4
 byte    108, 190, 105,    4
 byte    105, 191, 106,    4
 byte    191, 193, 106,    4
 byte    107, 106, 195,    4
 byte    195, 106, 193,    4
 byte    108, 107, 195,    4
 byte    108, 195, 190,    4
 byte    122, 119,  88,    5
 byte    119,  89,  88,    5
 byte    120, 121,   4,    5
 byte    121,   1,   4,    5
 byte    120,   4, 119,    5
 byte    119,   4,   0,    5
 byte    126, 123, 119,    5
 byte    126, 119, 122,    5
 byte    124, 119, 123,    5
 byte    124, 120, 119,    5
 byte    124, 125, 120,    5
 byte    125, 121, 120,    5
 byte    125, 122, 121,    5
 byte    126, 122, 125,    5
 byte    127, 123, 130,    5
 byte    130, 123, 126,    5
 byte    127, 128, 124,    5
 byte    127, 124, 123,    5
 byte    128, 125, 124,    5
 byte    129, 125, 128,    5
 byte    129, 130, 125,    5
 byte    130, 126, 125,    5
 byte    134, 131, 130,    5
 byte    131, 127, 130,    5
 byte    131, 128, 127,    5
 byte    132, 128, 131,    5
 byte    132, 133, 128,    5
 byte    133, 129, 128,    5
 byte    133, 130, 129,    5
 byte    134, 130, 133,    5
 byte    142, 139, 138,    4
 byte    139, 135, 138,    4
 byte    140, 136, 139,    4
 byte    139, 136, 135,    4
 byte    140, 141, 136,    4
 byte    141, 137, 136,    4
 byte    141, 138, 137,    4
 byte    142, 138, 141,    4
 byte    144, 141, 146,    4
 byte    144, 142, 141,    4
 byte    144, 145, 142,    4
 byte    140, 142, 145,    4
 byte    140, 145, 141,    4
 byte    145, 146, 141,    4
 byte    144, 149, 147,    4
 byte    144, 146, 149,    4
 byte    147, 148, 145,    4
 byte    144, 147, 145,    4
 byte    145, 148, 149,    4
 byte    145, 149, 146,    4
 byte    181, 182, 174,    2
 byte    174, 182, 150,    2
 byte     87, 165,  86,    4
 byte     86, 165, 176,    4
 byte    167, 151, 165,    4
 byte    151, 177, 165,    4
 byte    182, 183, 150,    2
 byte    150, 183, 177,    2
 byte    182,  85, 183,    2
 byte     85, 176, 183,    2
 byte    176, 165, 175,    1
 byte    165, 179, 175,    1
 byte    177, 179, 165,    1
 byte    177, 178, 179,    1
 byte    177, 184, 178,    1
 byte    183, 184, 177,    1
 byte    183, 176, 184,    1
 byte    176, 175, 184,    1
 byte    184, 175, 163,    2
 byte    175, 154, 163,    2
 byte    179, 155, 175,    2
 byte    175, 155, 154,    2
 byte    179, 178, 157,    2
 byte    178, 158, 157,    2
 byte    184, 159, 178,    2
 byte    184, 160, 159,    2
 byte     12, 173, 172,    4
 byte    172, 173, 181,    4
 byte     22,  15,  20,    4
 byte     22,  14,  15,    4
 byte     97,  96, 104,    4
 byte     97, 104, 102,    4
 byte    103, 105, 101,    4
 byte    105, 103, 108,    4
 byte     25,  20,  21,    4
 byte     25,  21,  26,    4
 byte    121,  88,  90,    5
 byte     88, 121, 122,    5
 byte     55,   7,   5,    5
 byte     55,   5,  56,    5

        org 0
Do3D    wrlong zero,PAR
:lp     rdlong calcaction,PAR wz
  if_z  jmp   #:lp

        mov   val,PAR
        add   val,#4
        mov   polyposptr,val
        add   val,#4
        mov   sortposptr,val

        cmp   calcaction,#1 wz
  if_z  call  #TranslatePoints

        cmp   calcaction,#2 wz
  if_z  call  #ClearSortList

        cmp   calcaction,#3 wz
  if_z  call  #AddPolys

        cmp   calcaction,#4 wz
  if_z  call  #DrawPolys

        jmp   #Do3D

calcaction long 0

ClearSortList
        mov   b,#256
        wrlong b,sortposptr
        mov   val,sortlistptr
:lp     wrlong zero,val
        add   val,#4
        djnz  b,#:lp
ClearSortList_ret ret

polyptrptr long 0
bufptr  long  0
bptr    long  0
backbufptr long 0
bakbuf2 long  0
POLYSETBACK long Lite#PROPGFX_POLY_SET_BASE
POLYCLS long  Lite#PROPGFX_POLY_CLS
POLYSTOP long Lite#PROPGFX_POLY_STOP

DrawPolys
        rdlong bakbuf2,backbufptr
        mov   bptr,bufptr
        wrword POLYSETBACK,bptr
        add   bptr,#2
        wrword bakbuf2,bptr
        add   bptr,#2
        wrword POLYCLS,bptr
        add   bptr,#2
        mov   apcount,#255      'j:=255
:lp
        cmp   apcount,#0 wz     'repeat while j<>0
  if_z  jmp   #:done
        mov   sortx1,apcount    'l:=j
        shl   sortx1,#2
        add   sortx1,sortlistptr
        rdlong sortx1,sortx1    'm:=sortlist[l]
:lp2    mov   sorty3,sortx1
        and   sortx1,xffff wz   'repeat while m&$ffff
  if_z  jmp   #:skp
        sub   sortx1,#1         'i:=m-1
        shl   sortx1,#2         'i<<2
        add   sortx1,polys      '+polysptr

        rdbyte sortx2,sortx1    'get index1
        add   sortx1,#1         'point to next index
        shl   sortx2,#1         'index1*2
        mov   sortmp,sortx2     'store in temp
        shl   sortx2,#1         'index1*4
        add   sortx2,sortmp     'index1*4 + index1*2 = index1*6 ( 3 words )
        add   sortx2,rotatebuf  '+ rotated vectors buf

        rdbyte sortx3,sortx1    'get index2
        add   sortx1,#1         'point to next index
        shl   sortx3,#1         'index2*2
        mov   sortmp,sortx3     'store in temp
        shl   sortx3,#1         'index2*4
        add   sortx3,sortmp     'index2*4 + index2*2 = index2*6 ( 3 words )
        add   sortx3,rotatebuf  '+ rotated vectors buf

        rdbyte sorty1,sortx1    'get index3
        add   sortx1,#1         'point to poly colour
        shl   sorty1,#1         'index3*2
        mov   sortmp,sorty1     'store in temp
        shl   sorty1,#1         'index3*4
        add   sorty1,sortmp     'index3*4 + index3*2 = index3*6 ( 3 words )
        add   sorty1,rotatebuf  '+ rotated vectors buf

        rdbyte sorty2,sortx1    'get colour
        add   sorty2,#16
        wrword sorty2,bptr      'put POLYC in buf
        add   bptr,#2

        rdword sorty2,sortx2    'get X1
        add   sortx2,#2         'point to Y1
        wrword sorty2,bptr      'write X1 to buf     
        add   bptr,#2           'next buf space
        rdword sorty2,sortx2    'get Y1
        wrword sorty2,bptr      'write Y1 to buf     
        add   bptr,#2           'next buf space
        
        rdword sorty2,sortx3    'get X2
        add   sortx3,#2         'point to Y2
        wrword sorty2,bptr      'write X2 to buf     
        add   bptr,#2           'next buf space
        rdword sorty2,sortx3    'get Y2
        wrword sorty2,bptr      'write Y2 to buf     
        add   bptr,#2           'next buf space

        rdword sorty2,sorty1    'get X3
        add   sorty1,#2         'point to Y3
        wrword sorty2,bptr      'write X3 to buf     
        add   bptr,#2           'next buf space
        rdword sorty2,sorty1    'get Y3
        wrword sorty2,bptr      'write Y3 to buf     
        add   bptr,#2           'next buf space

        shr   sorty3,#16        'l:=sortlist[l]>>16
        shl   sorty3,#2
        add   sorty3,sortlistptr
        rdlong sortx1,sorty3    'm:=sortlist[l]
        cmp   sortx1,#0 wz
  if_z  mov   sortx1,#0        
        jmp   #:lp2
:skp    djnz  apcount,#:lp
:done   wrword POLYSTOP,bptr
        add   bptr,#2
        wrlong bptr,polyptrptr                                   
DrawPolys_ret ret

{
    polyptr:=@buf
    word[polyptr][0]:=Lite#PROPGFX_POLY_SET_BASE
    polyptr+=2
    word[polyptr][0]:=bakbuf
    polyptr+=2
    word[polyptr][0]:=Lite#PROPGFX_POLY_CLS
    polyptr+=2
    j:=255
    repeat while j<>0
      l:=j
      m:=sortlist[l]&$ffff
      repeat while m
        i:=m-1
        k:=@akira000_faces+(i<<2)
          word[polyptr][POLYC]:=byte[k][3]+1
          word[polyptr][POLYX1]:=rotverts[byte[k][0]*3+0]
          word[polyptr][POLYY1]:=rotverts[byte[k][0]*3+1]
          word[polyptr][POLYX2]:=rotverts[byte[k][1]*3+0]
          word[polyptr][POLYY2]:=rotverts[byte[k][1]*3+1]
          word[polyptr][POLYX3]:=rotverts[byte[k][2]*3+0]
          word[polyptr][POLYY3]:=rotverts[byte[k][2]*3+1]
          polyptr+=POLYLN<<1
        l:=sortlist[l]>>16
        m:=sortlist[l]&$ffff
        if l==0
          m:=0
      j--
    word[polyptr][0]:=Lite#PROPGFX_POLY_STOP
    polyptr+=2
'}

xffff   long  $ffff

polyposptr long 0
sortlistptr long 0
apcount long  0        

AddPolys
        mov   pptr,polys
        mov   apcount,polycount
        mov   sorti,#0          'i
:lp     add   sorti,#1          'i+1 done here since it's not needed as i
        rdbyte sortz1,pptr      'get polyindex1
        add   pptr,#1           'point to polyindex2                
        mov   sortx1,sortz1     'set x1 to index1
        rdbyte sortz2,pptr      'get polyindex2
        add   pptr,#1           'point to polyindex3
        mov   sortx2,sortz2     'set x2 to index2
        rdbyte sortz3,pptr      'get polyindex3
        add   pptr,#2           'point to next poly
        mov   sortx3,sortz3     'set x3 to index3
        shl   sortx1,#1         'xindex*2
        add   sortz1,sortx1     'xindex now *3
        shl   sortz1,#1         'xindex now *6 for 3 words for vertex
        add   sortz1,rotatebuf  'add rotatebufptr

        rdword sortx1,sortz1    'get X for vert1
        shl   sortx2,#1         'yindex *2
        add   sortz1,#2         'point to Y for vert1
        rdword sorty1,sortz1    'get Y for vert1
        add   sortz2,sortx2     'yindex *3
        add   sortz1,#2         'point to Z for vert1
        rdword sortz1,sortz1    'get Z for vert1
        shl   sortz2,#1         'yindex now *6 for 3 words for vertex
        add   sortz2,rotatebuf  'add rotatebufptr
        rdword sortx2,sortz2    'get X for vert2
        shl   sortx3,#1         'zindex *2
        add   sortz2,#2         'point to Y for vert2
        rdword sorty2,sortz2    'get Y for vert2
        add   sortz3,sortx3     'zindex *3
        add   sortz2,#2         'point to Z for vert2
        rdword sortz2,sortz2    'get Z for vert2
        shl   sortz3,#1         'zindex now *6 for 3 words for vertex
        add   sortz3,rotatebuf  'add rotatebufptr

        rdword sortx3,sortz3    'get X for vert3
        add   sortz3,#2         'point to Y for vert3
        mov   div,sorty2        'get Y2
        rdword sorty3,sortz3    'get Y for vert3
        add   sortz3,#2         'point to Z for vert3
        sub   div,sorty1        'Y2 - Y1
        rdword sortz3,sortz3    'get Z for vert3

        mov   val,sortx3        'get X3
        sub   val,sortx1        'X3 - X1
        call  #multiply         'multiply X3-X1*Y2-Y1
        mov   sortmp,answer     'store answer in tmp for subtracting
        mov   div,sortx2        'get X2
        sub   div,sortx1        'X2 - X1
        mov   val,sorty3        'get Y3
        sub   val,sorty1        'Y3 - Y1
        call  #multiply         'multiply Y3-Y1*X2-X1
        sub   answer,sortmp     'minus tmp (X3-X1*Y2-Y1
        test  answer,x80000000 wz 'is it <0
  if_z  jmp   #:skpsort         'if so skip
        add   sortz3,sortz2     'Z3+Z2
        add   sortz3,sortz1     '+Z1
        mov   val,sortz3        'val=Z3+Z2+Z1
        mov   div,#85           '*85
        call  #multiply         'Z3+Z2+Z1 * 85
        sar   answer,#8         'Z3+Z2+Z1 * 85/256 roughly = /3
        and   answer,#255       'keep in Zsort
        shl   answer,#2         '<<2 for Long access
        mov   ssptr,sortlistptr 'ssptr=sortlistptr
        add   ssptr,answer      '+answer ( Zpos in table )
        rdlong b,ssptr wz       'check to see if there's poly already there
  if_z  wrlong sorti,ssptr      'if not write I which is (polynum+1)
  if_z  jmp   #:skpsort      'and skip next bit
        rdlong val,sortposptr   'get sortpos
        mov   div,val           'store in div for later
        shl   val,#2            '<<2 for long access
        add   val,sortlistptr   'add sortlistptr
        wrlong b,val            'write B ( old poly )
        mov   b,div             'get sortpos
        shl   div,#16           '<<16 to put in high word of long
        add   div,sorti         'add sorti ( polynum+1 ) ( eg put into lower word )
        wrlong div,ssptr        'store in sortlist
        add   b,#1              'sortpos ++
        wrlong b,sortposptr     'store back in sortpos hubram            
:skpsort
        djnz  apcount,#:lp
AddPolys_ret ret

sortx1  long  0
sorty1  long  0
sortz1  long  0
sortx2  long  0
sorty2  long  0
sortz2  long  0
sortx3  long  0
sorty3  long  0
sortz3  long  0
sortmp  long  0
ssptr   long  0
sorti   long  0
sortposptr long 0

        
GetSin  mov   answer,angle
        shl   answer,#1
        and   answer,xffe
        test  angle,x800 wz
  if_nz xor   answer,xffe
  if_nz add   answer,#2
        add   answer,xe000
        rdword answer,answer
        test  angle,x1000 wz
  if_nz neg   answer,answer
GetSin_ret ret

zero    long  0
angle   long  0
xffe    long  $ffe
x800    long  $800
x1000   long  $1000
xe000   long  $e000  

'
' Divide t1/m1 into t2
'
divide  mov   sign,#0
        test  val,x80000000 wz
  if_nz xor   sign,#1
  if_nz neg   val,val
        test  div,x80000000 wz
  if_nz xor   sign,#1
  if_nz neg   div,div
        mov   b,#32                   ' Divide a 32 bit unsigned dividend
        mov   remainder,#0            ' by a 32 bit unsigned divisor to
:loop   shl   val,#1          wc      ' get a 32 bit unsigned quotient
        rcl   remainder,#1            ' and a 32 bit unsigned remainder
        cmpsub remainder,div    wc,wr
        rcl   answer,#1
        djnz  b,#:loop
        test  sign,#1 wz
  if_nz neg   answer,answer
divide_ret ret
x80000000 long $80000000
val     long  0
div     long  0
b       long  0
answer  long  0
remainder long 0
sign    long  0

multiply mov  sign,#0
        test  val,x80000000 wz
  if_nz xor   sign,#1
  if_nz neg   val,val
        test  div,x80000000 wz
  if_nz xor   sign,#1
  if_nz neg   div,div
        mov   answer,#0
        mov   b,#32
:lp     shr   div,#1 wc
  if_c  add   answer,val
        shl   val,#1
        djnz  b,#:lp
        test  sign,#1 wz
  if_nz neg   answer,answer
multiply_ret  ret               
        

DVal    long  D            'Distance and Perspective
SDVal   long  SD
SZOVal  long  SZO
SZSVal  long  SZS
CXVal   long  CX             'Screen Center X 
CYVal   long  CY              'Screen Center Y

RotX    long  0
RotY    long  0
RotZ    long  0

pointcount long 209
vectors long  0
rotatebuf long 0
polys   long  0
polycount long 398

pcount  long  0
vptr    long  0
pptr    long  0
rptr    long  0

TranslatePoints
        add   RotY,#3
        
'    S1 := Sin((R1*1024)/45)                                                     'Convert DEG (0-360) to 13-Bit Sine and Cosine value        
        mov   val,RotX
        shl   val,#10
        mov   div,#45
        call  #divide
        mov   angle,answer
        call  #GetSin
        mov   SS1,answer

'    S2 := Sin((R2*1024)/45)
        mov   val,RotY
        shl   val,#10
        mov   div,#45
        call  #divide
        mov   angle,answer
        call  #GetSin
        mov   SS2,answer

'    S3 := Sin((R3*1024)/45)    
        mov   val,RotZ
        shl   val,#10
        mov   div,#45
        call  #divide
        mov   angle,answer
        call  #GetSin
        mov   SS3,answer

'    C1 := Cos((R1*1024)/45)
        mov   val,RotX
        shl   val,#10
        mov   div,#45
        call  #divide
        mov   angle,answer
        add   angle,x800
        call  #GetSin
        mov   CC1,answer

'    C2 := Cos((R2*1024)/45)
        mov   val,RotY
        shl   val,#10
        mov   div,#45
        call  #divide
        mov   angle,answer
        add   angle,x800
        call  #GetSin
        mov   CC2,answer

'    C3 := Cos((R3*1024)/45)
        mov   val,RotZ
        shl   val,#10
        mov   div,#45
        call  #divide
        mov   angle,answer
        add   angle,x800
        call  #GetSin
        mov   CC3,answer

        mov   vptr,vectors
        mov   rptr,rotatebuf
        mov   pcount,pointcount
        
:loop   rdword PntX,vptr             
        shl   PntX,#16
        add   vptr,#2
        rdword PntZ,vptr      ' swapped Y with Z because of model was drawn that way             
        shl   PntZ,#16
        add   vptr,#2
        rdword PntY,vptr      ' swapped Z with Y because of model was drawn that way             
        shl   PntY,#16
        add   vptr,#2
        
        sar   PntX,#16  'sign extend word to long
        sar   PntY,#16  'sign extend word to long
        sar   PntZ,#16  'sign extend word to long

'      TEMPX := (PointX * C2 - PointZ * S2) ~>16'/ 65535                              'Rotate points around the y axis.
        mov   val,PntZ
        mov   div,SS2
        call  #multiply
        mov   remainder,answer
        mov   val,PntX
        mov   div,CC2
        call  #multiply
        sub   answer,remainder
        sar   answer,#16
        mov   TmpX,answer
        
'      TEMPZ := (PointX * S2 + PointZ * C2) ~>16'/ 65535
        mov   val,PntZ
        mov   div,CC2
        call  #multiply
        mov   remainder,answer
        mov   val,PntX
        mov   div,SS2
        call  #multiply
        add   answer,remainder
        sar   answer,#16
        mov   TmpZ,answer

'      ScnPntZ := (TEMPZ * C1 - PointY * S1) ~>16'/ 65535                             'Rotate points around the x axis.
        mov   val,PntY
        mov   div,SS1
        call  #multiply
        mov   remainder,answer
        mov   val,TmpZ
        mov   div,CC1
        call  #multiply
        sub   answer,remainder
        sar   answer,#16
        mov   ScrZ,answer

'      TEMPY := (TEMPZ * S1 + PointY * C1) ~>16'/ 65535
        mov   val,PntY
        mov   div,CC1
        call  #multiply
        mov   remainder,answer
        mov   val,TmpZ
        mov   div,SS1
        call  #multiply
        add   answer,remainder
        sar   answer,#16
        mov   TmpY,answer

'      ScnPntX := (TEMPX * C3 + TEMPY * S3)~>16'/ 65535                               'Rotate points around the z axis.
        mov   val,TmpY
        mov   div,SS3
        call  #multiply
        mov   remainder,answer
        mov   val,TmpX
        mov   div,CC3
        call  #multiply
        add   answer,remainder
        sar   answer,#16
        mov   ScrX,answer

'      ScnPntY := (TEMPY * C3 - TEMPX * S3)~>16'/ 65535
        mov   val,TmpX
        mov   div,SS3
        call  #multiply
        mov   remainder,answer
        mov   val,TmpY
        mov   div,CC3
        call  #multiply
        sub   answer,remainder
        sar   answer,#16
        mov   ScrY,answer

'      TEMPZ := ScnPntZ - SD                                               'CONVERT 3D TO 2D
        mov   TmpZ,ScrZ
        sub   TmpZ,SDVal

'      SX[tpi] := ScnPntX * D / TEMPZ + CX                                 'Note: If TEMPZ < 0 points are off screen                                                         
        mov   val,ScrX
        mov   div,DVal
        call  #multiply
        mov   val,answer
        mov   div,TmpZ
        call  #divide
        add   answer,CXVal
        wrword answer,rptr
        add   rptr,#2         

'      SY[tpi] := ScnPntY * D / TEMPZ + CY
        mov   val,ScrY
        mov   div,DVal
        call  #multiply
        mov   val,answer
        mov   div,TmpZ
        call  #divide
        add   answer,CYVal
        wrword answer,rptr
        add   rptr,#2

'      SZ[tpi] := (-TEMPZ/SZS)-SZO
        mov   val,TmpZ
        neg   val,val
        mov   div,SZSVal
        call  #divide
        sub   answer,SZOval
        wrword answer,rptr
        add   rptr,#2         

        djnz  pcount,#:loop

TranslatePoints_ret ret

rt1     long  64
rt2     long  0
rt3     long  0
rt4     long  0
rt5     long  95
rt6     long  0
rt7     long  127
rt8     long  48
rt9     long  0

SS1     long  0           
SS2     long  0           
SS3     long  0           
CC1     long  0           
CC2     long  0           
CC3     long  0
PntX    long  0           
PntY    long  0           
PntZ    long  0           
TmpX    long  0           
TmpY    long  0           
TmpZ    long  0           
ScrX    long  0           
ScrY    long  0           
ScrZ    long  0

        fit   496